// Five In A Row Component
// Borland C++Builder 3
// Version 1.0
// Copyright (C) 2000 Gran berg, All Rights Reserved
//---------------------------------------------------------------------------
#ifndef FiveInARowH
#define FiveInARowH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <math.h>
#include <stdlib.h>
//---------------------------------------------------------------------------
// Size Definitions.
#define MAXCOLS 50
#define MINCOLS 5
#define MAXROWS 50
#define MINROWS 5

// Number of patterns.
#define PATTERNLENGTH 55

// Length of score array.
#define SCORELENGTH 2500

// Score definitions.
#define PRI8 100
#define PRI7 500
#define PRI6 2100
#define PRI5 8500
#define PRI4 34100
#define PRI3 136500
#define PRI2 546100
#define PRI1 2184600
//-- user supplied -----------------------------------------------------------
enum TStrength {stLow, stMedium, stHigh};
//---------------------------------------------------------------------------
class PACKAGE TFiveInARow : public TCustomControl
{
protected:
  TColor FColor, FGridLineColor, FCrossColor, FNoughtColor,
         FHighlightColor, FFiveInARowColor;
  TNotifyEvent FOnLegalMove, FOnIllegalMove, FOnDraw, FOnCrossWon,
               FOnNoughtWon, FOnComputerWon,FOnUserWon;
  bool FAutoResponse, FClickResponse, FGameOver, FLock, FShowHighlight,
       FShowFiveInARow, Winner;
  int FRowCount, FColCount;
  int Grid[MAXCOLS][MAXROWS];
  TStrength FPlayingStrength;

  class TPattern
  {
  public:
    int score, start, stop;
    int pattern[8];

    void setPattern(int sc, int st, int stp, int p1, int p2, int p3, int p4,
                    int p5, int p6, int p7, int p8)
    {
      score=sc;start=st;stop=stp;pattern[0]=p1;pattern[1]=p2;pattern[2]=p3;
      pattern[3]=p4;pattern[4]=p5;pattern[5]=p6;pattern[6]=p7;pattern[7]=p8;
    };

    void setPattern(int sc, int st, int stp, int p1, int p2, int p3, int p4,
                    int p5, int p6, int p7)
    {
      score=sc;start=st;stop=stp;pattern[0]=p1;pattern[1]=p2;pattern[2]=p3;
      pattern[3]=p4;pattern[4]=p5;pattern[5]=p6;pattern[6]=p7;
    };

    void setPattern(int sc, int st, int stp, int p1, int p2, int p3, int p4,
                    int p5, int p6)
    {
      score=sc;start=st;stop=stp;pattern[0]=p1;pattern[1]=p2;pattern[2]=p3;
      pattern[3]=p4;pattern[4]=p5;pattern[5]=p6;
    };

    void setPattern(int sc,int st,int stp,int p1,int p2,int p3,int p4,int p5)
    {
      score=sc;start=st;stop=stp;pattern[0]=p1;pattern[1]=p2;pattern[2]=p3;
      pattern[3]=p4;pattern[4]=p5;
    };
  }*P;

  struct TScore
  {
    int score;
    int x;
    int y;
  }*SC,*SN;

  struct TRememberCoords
  {
    int x;
    int y;
  } RememberCoords[5];

  int OldHiX, OldHiY, HiX, HiY, Turn;
  virtual void __fastcall Paint(void);
  DYNAMIC void __fastcall MouseDown(TMouseButton Button,
                                    Classes::TShiftState Shift, int X, int Y);
  void __fastcall SetColor(TColor AColor);
  void __fastcall SetGridLineColor(TColor AGridLineColor);
  void __fastcall SetCrossColor(TColor ACrossColor);
  void __fastcall SetNoughtColor(TColor ANoughtColor);
  void __fastcall SetHighlightColor(TColor AHighLightColor);
  void __fastcall SetFiveInARowColor(TColor AFiveInARowColor);
  void __fastcall SetColCount(int AColCount);
  void __fastcall SetRowCount(int ARowCount);
  void __fastcall DrawGraphics();
  bool __fastcall Check(int x, int y);

public:
  __fastcall TFiveInARow(TComponent* Owner);
  __fastcall ~TFiveInARow();
  void __fastcall Move(int x, int y);
  void __fastcall ComputerMove();
  void __fastcall NewGame();

__published:
  __property TColor Color={read=FColor, write=SetColor, default=true};
  __property TColor GridLineColor={read=FGridLineColor,
                                   write=SetGridLineColor, default=true};
  __property TColor CrossColor={read=FCrossColor,
                                write=SetCrossColor, default=true};
  __property TColor NoughtColor={read=FNoughtColor,
                                 write=SetNoughtColor, default=true};
  __property TColor HighlightColor={read=FHighlightColor,
                                    write=SetHighlightColor, default=true};
  __property TColor FiveInARowColor={read=FFiveInARowColor,
                                     write=SetFiveInARowColor, default=true};
  __property int ColCount={read=FColCount,write=SetColCount, default=true};
  __property int RowCount={read=FRowCount, write=SetRowCount, default=true};
  __property TStrength PlayingStrength={read=FPlayingStrength,
                                        write=FPlayingStrength, default=true};
  __property bool AutoResponse={read=FAutoResponse,
                                write=FAutoResponse, default=true};
  __property bool ClickResponse={read=FClickResponse,
                                 write=FClickResponse, default=true};
  __property bool Lock={read=FLock, write=FLock, default=true};
  __property bool ShowHighlight={read=FShowHighlight,
                                 write=FShowHighlight, default=true};
  __property bool ShowFiveInARow={read=FShowFiveInARow,
                                  write=FShowFiveInARow, default=true};
  __property bool GameOver={read=FGameOver, default=true};
  __property Align;
  __property Visible;
  __property OnMouseDown;
  __property OnMouseUp;
  __property OnMouseMove;
  __property OnClick;
  __property OnDblClick;
  __property OnEnter;
  __property OnExit;
  __property TNotifyEvent OnLegalMove= {read=FOnLegalMove, write=FOnLegalMove};
  __property TNotifyEvent OnIllegalMove= {read=FOnIllegalMove,
                                          write=FOnIllegalMove};
  __property TNotifyEvent OnDraw={read=FOnDraw, write=FOnDraw};
  __property TNotifyEvent OnCrossWon={read=FOnCrossWon, write=FOnCrossWon};
  __property TNotifyEvent OnNoughtWon={read=FOnNoughtWon, write=FOnNoughtWon};
  __property TNotifyEvent OnComputerWon={read=FOnComputerWon,
                                         write=FOnComputerWon};
  __property TNotifyEvent OnUserWon={read=FOnUserWon, write=FOnUserWon};
};
//---------------------------------------------------------------------------
#endif
